#version 150
// object space to camera space transformation
uniform mat4 modelview_matrix;
 
// camera space to clip coordinates
uniform mat4 projection_matrix;

// incoming vertex position
in vec2 vertex_position;
// incoming vertex color
in vec4 vertex_color;

in vec2 sprite_size;
in float sprite_texture_id;
in float sprite_angle;


out vec2 wSize;
out vec2 sSize;
out float sTexture;
out float sAngle;
out vec4 sColor;

const float PI = 3.1415926;
 
void main(void) {
	wSize = (projection_matrix * vec4(1, 1, 0, 0)).xy/2;
	sSize = sprite_size;
	sTexture = sprite_texture_id;
	sAngle = sprite_angle*PI;
	sColor = vertex_color;
	
	// transforming the incoming vertex position
	gl_Position = projection_matrix * vec4(vertex_position, 0, 1);
}